Host Group creation may fail if Host Group with id 1 exists with same parameter name
Pull request:    

Description

I believe the cause is similar to issue #4731. On a production RHEL or Centos install, when creating a Host Group and specifying

some parameter, if a host group with ID = 1 already exists with that same parameter name the creation will fail with error "Name has

already been taken".  The cause is that when this validation is run:

validates :name, :uniqueness => {:scope => :reference_id}

 The new parameter's reference_id is set to 1 instead of nil.  Thus if a host group already exists with this parameter name (and that

host group has an ID of 1), the validation will fail.

Here is an example of a validation:

GroupParameter Exists (0.2ms) SELECT 1 AS one FROM "parameters" WHERE "parameters"."type" IN ('GroupParameter') AND

("parameters"."name" = 'kt_org' AND "parameters"."reference_id" = 1) LIMIT 1

This was the sql generated with a new host group submission.

NOTE: this will not occur on a development install using the latest version of Rails 3.2.

Related issues:

Related to Foreman - Bug #6375: Can't create parameters for operating system ... Closed 06/25/2014

Associated revisions

Revision 691f0a1a - 06/17/2014 09:53 AM - Joseph Magen

fixes #5129 - Host Group creation may fail if parameter is same name

Revision 4a29b9eb - 07/28/2014 07:15 AM - Joseph Magen

fixes #5129 - Host Group creation may fail if parameter is same name

(cherry picked from commit 691f0a1a809569d125e9385e60f8f1e1c8d88061)

History

#1 - 04/09/2014 04:03 PM - Dominic Cleal

- Category set to Database

- Status changed from New to Ready For Testing

- Target version set to 1.8.4

https://github.com/theforeman/foreman/pull/1366/files

#2 - 04/15/2014 01:57 PM - Dominic Cleal

- Status changed from Ready For Testing to New

- Target version deleted (1.8.4)
https://projects.theforeman.org/issues/4731
https://github.com/theforeman/foreman/pull/1366/files


PR closed.

#3 - 05/30/2014 06:20 PM - Justin Sherrill

- Bugzilla link set to https://bugzilla.redhat.com/show_bug.cgi?id=1103321

#4 - 06/17/2014 07:23 AM - Dominic Cleal

- Status changed from New to Ready For Testing

- Assignee set to Joseph Magen

- Target version set to 1.8.1

https://github.com/theforeman/foreman/pull/1504

#5 - 06/17/2014 09:52 AM - Dominic Cleal

- translation missing: en.field_release set to 18

#6 - 06/17/2014 10:31 AM - Joseph Magen

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 691f0a1a809569d125e9385e60f8f1e1c8d88061.

#7 - 07/21/2014 11:24 AM - Dominic Cleal

- Related to Bug #6375: Can't create parameters for operating system with id 1 using API added

Powered by TCPDF (www.tcpdf.org)

05/12/2024 2/2

https://github.com/theforeman/foreman/pull/1504
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/691f0a1a809569d125e9385e60f8f1e1c8d88061
http://www.tcpdf.org

